/* sdr_beta.c - beta loader (SCSI Direct Read)
 * Copyright (C) 2000 Tachibana Eriko
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#include <sys/iocs.h>

#include "isd_header.h"
#include "sdr.h"


/* Function */
int
sdr_beta (SDR* sdr, int frame_num, int frame_size, char* buf)
{
  IsdFrameHeader* hed = (IsdFrameHeader*) buf;

  while (--frame_num >= 0
	&& SDRread (sdr, buf, frame_size) == frame_size)
    {
      unsigned char* gvram = hed->gvram;
      unsigned long* g_data = (unsigned long*) hed->g_data;
      unsigned short y = hed->y_length;

      do
	{
	  unsigned long* p = (unsigned long*) gvram;
	  unsigned short x = hed->x_length / 2;

	  /* PC] */
	  do
	    *p++ = *g_data++;
	  while (--x);

	  gvram += hed->x_offset;
	}
      while (--y);

      if (*(short*)0x812 && _iocs_b_keysns () && (_iocs_b_keyinp () & 0xff) == 0x1b)
	return _iocs_b_sftsns () & 1;	/* ESC ĂI */
    }

  return 0;
}

/* EOF */
