# yat_de.s - YAT decoder
# Copyright (C) 1999 Yuki,Takafumi
# Copyright (C) 2000 Tachibana Eriko
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA


* Include File -------------------------------- *

		.include	macro.mac


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even


* C function interface ------------------------ *

_YatDecode::
		movea.l	(4,sp),a0
		PUSH	d3-d7/a2-a5

		movea.l	(a0)+,a1		;gvram
		moveq	#0,d0
		move	(a0)+,d0		;x_length
		move	(a0)+,d1		;y_length
		move.l	(a0)+,d2		;x_offset
		addq.l	#8,a0			;y_offset / g_size

		lea	(CULC_X_LENGTH,pc),a2
		sub.l	d0,d2
		sub.l	d0,d2

		lsr	#1,d0
		subq	#1,d0
		move	d0,(a2)+		;CULC_X_LENGTH = X/2-1

		move.l	d2,(a2)+		;CULC_Y_LENGTH

		subq	#1,d1
		move	d1,(a2)+		;YAT_YSIZE= Y-1

		bsr	YatDecode0

		POP	d3-d7/a2-a5
		rts


******************************************************************
**			YAT decode (a0 to a1)			**
******************************************************************
*************************************************
*		Normal Screen Draw		*
*************************************************
YatDecode0::
	move.l	(a0)+,d1			* d1 = ibit size
	move.l	(a0)+,d2			* d2 = flag size
	move.l	(a0)+,d3			* d3 = diff size

	tst.l	d2
	beq	YatDecode0_F
	tst.l	d1
	beq	YatDecode0_N

*********
* I bit *
*********
YatDecode0_I::
						* a0 = Pxrbgobt@
						* a1 = ݃obt@
	lea.l	(a0,d1.l),a2			* a2 = tOobt@
	lea.l	(a2,d2.l),a3			* a3 = obt@
	lea.l	(a3,d3.l),a4			* a4 = J[obt@
	lea.l	YAT_TABLE_I(pc),a5		* a5 = e[u
						* d0 = [N
						* d1 = Pxrbg
						* d2 = tO
						* d3 = counter
	clr.w	d4				* d4 = 
						* d5 = OF 
	move.w	CULC_X_LENGTH(pc),d6		* d6 = X Loop
	move.w	YAT_YSIZE(pc),d7		* d7 = Y Loop

1:		move.l	(a0)+,d1			* ibit ǂݍ
		move.l	(a2)+,d2			* flag ǂݍ
		moveq.l	#1,d3
2:		add.l	d2,d2
		bcs	10f				* OF
		move.w	(a4)+,d5			* FR[hǂݍ
		bpl	20f				* ͍
10:		move.w	d5,d0
		add.l	d1,d1
		addx.w	d0,d0
		move.w	d0,(a1)+			* G-VRAMɏA
		add.l	d2,d2
		bcs	11f				* OF
		move.w	(a4)+,d5			* FR[hǂݍ
		bpl	21f				* ͍
11:		move.w	d5,d0
		add.l	d1,d1
		addx.w	d0,d0
		move.w	d0,(a1)+			* G-VRAMɏB
		add.w	d3,d3
		dbeq	d6,2b
		dbne	d6,1b
	move.w	CULC_X_LENGTH(pc),d6
	adda.l	CULC_Y_LENGTH(pc),a1
	tst.w	d3
	dbeq	d7,2b
	dbne	d7,1b
	rts

3:		move.l	(a0)+,d1			* ibit ǂݍ
		move.l	(a2)+,d2			* flag ǂݍ
		moveq.l	#1,d3
4:		add.l	d2,d2
		bcs	20f				* OF
		move.b	(a3)+,d4			* ǂݍ
		bmi	30f				* ͐FR[h
		add.b	d4,d4
		add.w	(a5,d4.w),d5
20:		move.w	d5,d0
		add.l	d1,d1
		addx.w	d0,d0
		move.w	d0,(a1)+			* G-VRAMɏA
		add.l	d2,d2
		bcs	21f				* OF
		move.b	(a3)+,d4			* ǂݍ
		bmi	31f				* ͐FR[h
		add.b	d4,d4
		add.w	(a5,d4.w),d5
21:		move.w	d5,d0
		add.l	d1,d1
		addx.w	d0,d0
		move.w	d0,(a1)+			* G-VRAMɏB
		add.w	d3,d3
		dbeq	d6,4b
		dbne	d6,3b
	move.w	CULC_X_LENGTH(pc),d6
	adda.l	CULC_Y_LENGTH(pc),a1
	tst.w	d3
	dbeq	d7,4b
	dbne	d7,3b
	rts

30:		add.b	d4,d4
		add.w	(a5,d4.w),d5
		move.w	d5,d0
		add.l	d1,d1
		addx.w	d0,d0
		move.w	d0,(a1)+			* G-VRAMɏA
		add.l	d2,d2
		bcs	11b				* OF
		move.w	(a4)+,d5			* FR[hǂݍ
		bpl	21b				* ͍
		move.w	d5,d0
		add.l	d1,d1
		addx.w	d0,d0
		move.w	d0,(a1)+			* G-VRAMɏB
		add.w	d3,d3
		dbeq	d6,2b
		dbne	d6,1b
	move.w	CULC_X_LENGTH(pc),d6
	adda.l	CULC_Y_LENGTH(pc),a1
	tst.w	d3
	dbeq	d7,2b
	dbne	d7,1b
	rts

31:		add.b	d4,d4
		add.w	(a5,d4.w),d5
		move.w	d5,d0
		add.l	d1,d1
		addx.w	d0,d0
		move.w	d0,(a1)+			* G-VRAMɏB
		add.w	d3,d3
		dbeq	d6,2b
		dbne	d6,1b
	move.w	CULC_X_LENGTH(pc),d6
	adda.l	CULC_Y_LENGTH(pc),a1
	tst.w	d3
	dbeq	d7,2b
	dbne	d7,1b
	rts

*************
* Not I bit *
*************
YatDecode0_N::
						* a0 = gp
						* a1 = ݃obt@
	lea.l	(a0,d1.l),a2			* a2 = tOobt@
	lea.l	(a2,d2.l),a3			* a3 = obt@
	lea.l	(a3,d3.l),a4			* a4 = J[obt@
	lea.l	YAT_TABLE_N(pc),a5		* a5 = e[u
	move.w	CULC_X_LENGTH(pc),d0		* d0 = CULC_X_LENGTH
	move.l	CULC_Y_LENGTH(pc),d1		* d1 = CULC_Y_LENGTH
						* d2 = tO
						* d3 = counter
	clr.w	d4				* d4 = 
						* d5 = OF 
	move.w	d0,d6				* d6 = X Loop
	move.w	YAT_YSIZE(pc),d7		* d7 = Y Loop

1:		move.l	(a2)+,d2			* flag ǂݍ
		moveq.l	#1,d3
2:		add.l	d2,d2
		bcs	10f				* OF
		move.w	(a4)+,d5			* FR[hǂݍ
		add.w	d5,d5
		bcc	20f				* ͍
10:		move.w	d5,(a1)+			* G-VRAMɏA
		add.l	d2,d2
		bcs	11f				* OF
		move.w	(a4)+,d5			* FR[hǂݍ
		add.w	d5,d5
		bcc	21f				* ͍
11:		move.w	d5,(a1)+			* G-VRAMɏB
		add.w	d3,d3
		dbeq	d6,2b
		dbne	d6,1b
	move.w	d0,d6
	adda.l	d1,a1
	tst.w	d3
	dbeq	d7,2b
	dbne	d7,1b
	rts

3:		move.l	(a2)+,d2			* flag ǂݍ
		moveq.l	#1,d3
4:		add.l	d2,d2
		bcs	20f				* OF
		move.b	(a3)+,d4			* ǂݍ
		bmi	30f				* ͐FR[h
		add.b	d4,d4
		add.w	(a5,d4.w),d5
20:		move.w	d5,(a1)+			* G-VRAMɏA
		add.l	d2,d2
		bcs	21f				* OF
		move.b	(a3)+,d4			* ǂݍ
		bmi	31f				* ͐FR[h
		add.b	d4,d4
		add.w	(a5,d4.w),d5
21:		move.w	d5,(a1)+			* G-VRAMɏB
		add.w	d3,d3
		dbeq	d6,4b
		dbne	d6,3b
	move.w	d0,d6
	adda.l	d1,a1
	tst.w	d3
	dbeq	d7,4b
	dbne	d7,3b
	rts

30:		add.b	d4,d4
		add.w	(a5,d4.w),d5
		move.w	d5,(a1)+			* G-VRAMɏA
		add.l	d2,d2
		bcs	11b				* OF
		move.w	(a4)+,d5			* FR[hǂݍ
		add.w	d5,d5
		bcc	21b				* ͍
		move.w	d5,(a1)+			* G-VRAMɏB
		add.w	d3,d3
		dbeq	d6,2b
		dbne	d6,1b
	move.w	d0,d6
	adda.l	d1,a1
	tst.w	d3
	dbeq	d7,2b
	dbne	d7,1b
	rts

31:		add.b	d4,d4
		add.w	(a5,d4.w),d5
		move.w	d5,(a1)+			* G-VRAMɏB
		add.w	d3,d3
		dbeq	d6,2b
		dbne	d6,1b
	move.w	d0,d6
	adda.l	d1,a1
	tst.w	d3
	dbeq	d7,2b
	dbne	d7,1b
	rts

***************
* Fast Decode *
***************
YatDecode0_F::
						* a0 = tOobt@
						* a1 = ݃obt@
						* a2 = gp
	lea.l	(a0,d1.l),a3			* a3 = obt@
	lea.l	(a3,d3.l),a4			* a4 = J[obt@
	lea.l	YAT_TABLE_F(pc),a5		* a5 = e[u
	move.w	CULC_X_LENGTH(pc),d0		* d0 = CULC_X_LENGTH
	move.l	CULC_Y_LENGTH(pc),d1		* d1 = CULC_Y_LENGTH
						* d2 = tO
						* d3 = counter
						* d4 = 
						* d5 = OF 
	move.w	d0,d6				* d6 = X Loop
	move.w	YAT_YSIZE(pc),d7		* d7 = Y Loop

1:		move.l	(a0)+,d2			* flag ǂݍ
		moveq.l	#1,d3
2:		add.l	d2,d2
		bcc	20f				* FR[h
10:		clr.w	d4
		move.b	(a3)+,d4			* ǂݍ
		add.w	d4,d4
		add.w	(a5,d4.w),d5
		move.w	d5,(a1)+			* G-VRAMɏA
		add.l	d2,d2
		bcc	21f				* FR[h
11:		clr.w	d4
		move.b	(a3)+,d4			* ǂݍ
		add.w	d4,d4
		add.w	(a5,d4.w),d5
		move.w	d5,(a1)+			* G-VRAMɏB
		add.w	d3,d3
		dbeq	d6,2b
		dbne	d6,1b
	move.w	d0,d6
	adda.l	d1,a1
	tst.w	d3
	dbeq	d7,2b
	dbne	d7,1b
	rts

20:		move.w	(a4)+,d5			* FR[hǂݍ
		move.w	d5,(a1)+			* G-VRAMɏA
		add.l	d2,d2
		bcs	11b				* 
21:		move.w	(a4)+,d5			* FR[hǂݍ
		move.w	d5,(a1)+			* G-VRAMɏB
		add.w	d3,d3
		dbeq	d6,2b
		dbne	d6,1b
	move.w	d0,d6
	adda.l	d1,a1
	tst.w	d3
	dbeq	d7,2b
	dbne	d7,1b
	rts


* Data Section -------------------------------- *

		.data
		.even

CULC_X_LENGTH:		.ds.w	1
CULC_Y_LENGTH:		.ds.l	1
YAT_YSIZE:		.ds.w	1

*************************************************
*		YAT Table ( I bit )		*
*************************************************
YAT_TABLE_I::
  .irp		g,-2,-1,0,+1,+2
    .irp	r,-2,-1,0,+1,+2
      .irp	b,-2,-1,0,+1,+2
	.dc	g*1024+r*32+b
      .endm
    .endm
  .endm
*************************************************
*		YAT Table ( Not I bit )		*
*************************************************
YAT_TABLE_N::
  .irp		g,-2,-1,0,+1,+2
    .irp	r,-2,-1,0,+1,+2
      .irp	b,-2,-1,0,+1,+2
	.dc	(g*1024+r*32+b)<<1
      .endm
    .endm
  .endm
*************************************************
*		YAT Table ( Fast Decode )	*
*************************************************
YAT_TABLE_F:
  .irp		g,-2,-1,0,+1,+2
    .irp	r,-2,-1,0,+1,+2
      .irp	b,-4,-3,-2,-1,0,+1,+2,+3,+4
	.dc	g*2048+r*64+b
      .endm
    .endm
  .endm


		.end

* End of File --------------------------------- *
