.include	nenetto.mac
.include	_doscall.mac

		.offset	0
P_fname1:	.ds.l	1
P_fname2:	.ds.l	1
Dw_handle1:	.ds.w	1
Dw_handle2:	.ds.w	1
D_fsize1:	.ds.l	1
D_fsize2:	.ds.l	1
P_buff1:	.ds.l	1
P_buff2:	.ds.l	1
D_last_seek1:	.ds.l	1
D_last_read1:	.ds.l	1
F_mono:		.ds.b	1
buffer_length:
		.text

start:
	lea	B_buff(pc),a6
	 bsr	_option_check
	bmi	usage

	SET_BLOCK
	MALLOC	#512*1024+256*1024
	move.l	d0,P_buff1(a6)			*
	bmi	malloc_err
	add.l	#512*1024,d0
	move.l	d0,P_buff2(a6)			*

	OPEN	P_fname1(a6),#0
	tst.l	d0
	bmi	file_open_err
	move.w	d0,Dw_handle1(a6)		*

	SEEK	d0,#0,#2
	move.l	d0,D_fsize1(a6)			*
	lsr.l	#1,d0
	move.l	d0,D_fsize2(a6)			*

	CREATE	P_fname2(a6),#%10_0000
	tst.l	d0
	bmi	file_create_err
	move.w	d0,Dw_handle2(a6)		*

	@@:	SEEK	Dw_handle1(a6),D_last_seek1(a6),#0
		READ	Dw_handle1(a6),P_buff1(a6),#512*1024
		move.l	d0,D_last_read1(a6)
		bmi	file_read_err
		
		 bsr	_trans
		
		move.l	D_last_seek1(a6),d0
		lsr.l	#1,d0
		SEEK	Dw_handle2(a6),d0,#0
		move.l	D_last_read1(a6),d0
		lsr.l	#1,d0
		WRITE	Dw_handle2(a6),P_buff2(a6),d0
		tst.l	d0
		bmi	file_write_err
		
		add.l	#512*1024,D_last_seek1(a6)
	cmp.l	#512*1024,D_last_read1(a6)
	beq	@b

	EXIT


_trans:
	tst.b	F_mono(a6)
	bne	_trans_m
	
	movea.l	P_buff1(a6),a0
	movea.l	P_buff2(a6),a1
	move.l	#512*1024/8,d7
	@@:	move.w	(a0)+,d0
		move.w	(a0)+,d1
		move.w	(a0)+,d2
		move.w	(a0)+,d3
		ext.l	d0
		ext.l	d1
		ext.l	d2
		ext.l	d3
		add.l	d2,d0
		add.l	d3,d1
		asr.l	#1,d0
		asr.l	#1,d1
		move.w	d0,(a1)+
		move.w	d1,(a1)+
	subq.l	#1,d7
	bhi	@b
	rts


_trans_m:
	movea.l	P_buff1(a6),a0
	movea.l	P_buff2(a6),a1
	move.l	#512*1024/8,d7
	@@:	move.w	(a0)+,d0
		move.w	(a0)+,d1
		move.w	(a0)+,d2
		move.w	(a0)+,d3
		ext.l	d0
		ext.l	d1
		ext.l	d2
		ext.l	d3
		add.l	d1,d0
		add.l	d3,d2
		asr.l	#1,d0
		asr.l	#1,d2
		move.w	d0,(a1)+
		move.w	d2,(a1)+
	subq.l	#1,d7
	bhi	@b
	rts


_option_check:
	sf	F_mono(a6)
	tst.b	(a2)+
	beq	4f
	cmp.b	#'-',(a2)
	bne	3f
1:	cmp.b	#'m',1(a2)
	bne	4f
	st	F_mono(a6)
	addq.w	#2,a2
2:	cmp.b	#' ',(a2)+
	beq	2b
	subq.w	#1,a2
3:	move.l	a2,P_fname1(a6)
1:	cmp.b	#' ',(a2)+
	bne	1b
	clr.b	-1(a2)
2:	move.b	(a2)+,d0
	beq	4f
	cmp.b	#' ',d0
	beq	2b
	subq	#1,a2
	move.l	a2,P_fname2(a6)
	moveq	#0,d0
	rts
4:	moveq	#-1,d0
	rts


usage:
	PRINT	M_usage(pc)
	EXIT2	#2

malloc_err:
	PRINT	M_malloc_err(pc)
	bra	@f

file_open_err:
	PRINT	M_fopen_err(pc)
	bra	@f

file_read_err:
	PRINT	M_fread_err(pc)
	bra	@f

file_create_err:
	PRINT	M_fcreate_err(pc)
	bra	@f

file_write_err:
	PRINT	M_fwrite_err(pc)
@@:	EXIT2	#1


		.data
M_usage:	.dc.b	"16bit PCM frequency down converter Ver 1.0 Tonkyun'95",CR,LF
		.dc.b	'Usage: 44to22.x [-m] infile outfile',CR,LF,0
M_malloc_err:	.dc.b	'no memory!',CR,LF,0
M_fopen_err:	.dc.b	'file open error!',CR,LF,0
M_fread_err:	.dc.b	'file read error!',CR,LF,0
M_fcreate_err:	.dc.b	'file create error!',CR,LF,0
M_fwrite_err:	.dc.b	'file write error!',CR,LF,0
		.even

		.bss
B_buff:		.ds.b	buffer_length

		.end
